Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class TreeMap

    java.lang.Object
      |
      +--java.util.AbstractMap
            |
            +--java.util.TreeMap

All Implemented Interfaces:
  Cloneable, Map, Serializable, SortedMap

public class TreeMap
extends AbstractMap
implements SortedMap, Cloneable, Serializable

Red-Black tree based implementation of the `SortedMap` interface. This class guarantees that the map will be in ascending key order, sorted according to the natural order for the key's class (see `Comparable`), or by the comparator provided at creation time, depending on which constructor is used.

This implementation provides guaranteed log(n) time cost for the `containsKey`, `get`, `put` and `remove` operations. Algorithms are adaptations of those in Cormen, Leiserson, and Rivest's Introduction to Algorithms.

Note that the ordering maintained by a sorted map (whether or not an explicit comparator is provided) must be consistent with equals if this sorted map is to correctly implement the `Map` interface. (See `Comparable` or `Comparator` for a precise definition of consistent with equals.) This is so because the `Map` interface is defined in terms of the equals operation, but a map performs all key comparisons using its `compareTo` (or `compare`) method, so two keys that are deemed equal by this method are, from the standpoint of the sorted map, equal. The behavior of a sorted map is well-defined even if its ordering is inconsistent with equals; it just fails to obey the general contract of the `Map` interface.

Note that this implementation is not synchronized. If multiple threads access a map concurrently, and at least one of the threads modifies the map structurally, it must be synchronized externally. (A structural modification is any operation that adds or deletes one or more mappings; merely changing the value associated with an existing key is not a structural modification.) This is typically accomplished by synchronizing on some object that naturally encapsulates the map. If no such object exists, the map should be "wrapped" using the `Collections.synchronizedMap` method. This is best done at creation time, to prevent accidental unsynchronized access to the map:

         Map m = Collections.synchronizedMap(new TreeMap(...));

The iterators returned by all of this class's "collection view methods" are fail-fast: if the map is structurally modified at any time after the iterator is created, in any way except through the iterator's own `remove` or `add` methods, the iterator throws a `ConcurrentModificationException`. Thus, in the face of concurrent modification, the iterator fails quickly and cleanly, rather than risking arbitrary, non-deterministic behavior at an undetermined time in the future.

Since:
  1.2
See Also:
  `Map`, `HashMap`, `Hashtable`, `Comparable`, `Comparator`, `Collection`, `Collections.synchronizedMap(Map)`, Serialized Form

Inner classes inherited from class java.util.Map
`Map.Entry`

Constructor Summary
`TreeMap()` Constructs a new, empty map, sorted according to the keys' natural order.
`TreeMap(Comparator c)` Constructs a new, empty map, sorted according to the given comparator.
`TreeMap(Map m)` Constructs a new map containing the same mappings as the given map, sorted according to the keys' natural order.
`TreeMap(SortedMap m)` Constructs a new map containing the same mappings as the given `SortedMap`, sorted according to the same ordering.

Method Summary
`void` | `clear()` Removes all mappings from this TreeMap.
`Object` | `clone()` Returns a shallow copy of this `TreeMap` instance.
`Comparator` | `comparator()` Returns the comparator used to order this map, or `null` if this map uses its keys' natural order.
`boolean` | `containsKey(Object key)` Returns `true` if this map contains a mapping for the specified key.
`boolean` | `containsValue(Object value)` Returns `true` if this map maps one or more keys to the specified value.
`Set` | `entrySet()` Returns a set view of the mappings contained in this map.
`Object` | `firstKey()` Returns the first (lowest) key currently in this sorted map.
`Object` | `get(Object key)` Returns the value to which this map maps the specified key.
`SortedMap` | `headMap(Object toKey)` Returns a view of the portion of this map whose keys are strictly less than `toKey`.
`Set` | `keySet()` Returns a Set view of the keys contained in this map.
`Object` | `lastKey()` Returns the last (highest) key currently in this sorted map.
`Object` | `put(Object key, Object value)` Associates the specified value with the specified key in this map.
`void` | `putAll(Map map)` Copies all of the mappings from the specified map to this map.
`Object` | `remove(Object key)` Removes the mapping for this key from this TreeMap if present.
`int` | `size()` Returns the number of key-value mappings in this map.
`SortedMap` | `subMap(Object fromKey, Object toKey)` Returns a view of the portion of this map whose keys range from `fromKey`, inclusive, to `toKey`, exclusive.
`SortedMap` | `tailMap(Object fromKey)` Returns a view of the portion of this map whose keys are greater than or equal to `fromKey`.
`Collection` | `values()` Returns a collection view of the values contained in this map.

Methods inherited from class java.util.AbstractMap
`equals, hashCode, isEmpty, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`equals, hashCode, isEmpty`

Constructor Detail

### TreeMap

    public TreeMap()

  Constructs a new, empty map, sorted according to the keys' natural order. All keys inserted into the map must implement the `Comparable` interface. Furthermore, all such keys must be mutually comparable: `k1.compareTo(k2)` must not throw a ClassCastException for any elements `k1` and `k2` in the map. If the user attempts to put a key into the map that violates this constraint (for example, the user attempts to put a string key into a map whose keys are integers), the `put(Object key, Object value)` call will throw a `ClassCastException`.
  See Also:
    `Comparable`

### TreeMap

    public TreeMap(Comparator c)

  Constructs a new, empty map, sorted according to the given comparator. All keys inserted into the map must be mutually comparable by the given comparator: `comparator.compare(k1, k2)` must not throw a `ClassCastException` for any keys `k1` and `k2` in the map. If the user attempts to put a key into the map that violates this constraint, the `put(Object key, Object value)` call will throw a `ClassCastException`.
  Parameters:
    `c` - the comparator that will be used to sort this map. A `null` value indicates that the keys' natural ordering should be used.

### TreeMap

    public TreeMap(Map m)

  Constructs a new map containing the same mappings as the given map, sorted according to the keys' natural order. All keys inserted into the new map must implement the `Comparable` interface. Furthermore, all such keys must be mutually comparable: `k1.compareTo(k2)` must not throw a `ClassCastException` for any elements `k1` and `k2` in the map. This method runs in n*log(n) time.
  Parameters:
    `m` - the map whose mappings are to be placed in this map.
  Throws:
    `ClassCastException` - the keys in t are not Comparable, or are not mutually comparable.

### TreeMap

    public TreeMap(SortedMap m)

  Constructs a new map containing the same mappings as the given `SortedMap`, sorted according to the same ordering. This method runs in linear time.
  Parameters:
    `m` - the sorted map whose mappings are to be placed in this map, and whose comparator is to be used to sort this map.

Method Detail

### size

    public int size()

  Returns the number of key-value mappings in this map.
  Specified by:
    `size` in interface `Map`
  Overrides:
    `size` in class `AbstractMap`
  Returns:
    the number of key-value mappings in this map.

### containsKey

    public boolean containsKey(Object key)

  Returns `true` if this map contains a mapping for the specified key.
  Specified by:
    `containsKey` in interface `Map`
  Overrides:
    `containsKey` in class `AbstractMap`
  Parameters:
    `key` - key whose presence in this map is to be tested.
  Returns:
    `true` if this map contains a mapping for the specified key.
  Throws:
    `ClassCastException` - if the key cannot be compared with the keys currently in the map.
    `NullPointerException` - key is `null` and this map uses natural ordering, or its comparator does not tolerate `null` keys.

### containsValue

    public boolean containsValue(Object value)

  Returns `true` if this map maps one or more keys to the specified value. More formally, returns `true` if and only if this map contains at least one mapping to a value `v` such that `(value==null ? v==null : value.equals(v))`. This operation will probably require time linear in the Map size for most implementations of Map.
  Specified by:
    `containsValue` in interface `Map`
  Overrides:
    `containsValue` in class `AbstractMap`
  Parameters:
    `value` - value whose presence in this Map is to be tested.
  Since:
    1.2

### get

    public Object get(Object key)

  Returns the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key. A return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The `containsKey` operation may be used to distinguish these two cases.
  Specified by:
    `get` in interface `Map`
  Overrides:
    `get` in class `AbstractMap`
  Parameters:
    `key` - key whose associated value is to be returned.
  Returns:
    the value to which this map maps the specified key, or `null` if the map contains no mapping for the key.
  Throws:
    `ClassCastException` - key cannot be compared with the keys currently in the map.
    `NullPointerException` - key is `null` and this map uses natural ordering, or its comparator does not tolerate `null` keys.
  See Also:
    `containsKey(Object)`

### comparator

    public Comparator comparator()

  Returns the comparator used to order this map, or `null` if this map uses its keys' natural order.
  Specified by:
    `comparator` in interface `SortedMap`
  Returns:
    the comparator associated with this sorted map, or `null` if it uses its keys' natural sort method.

### firstKey

    public Object firstKey()

  Returns the first (lowest) key currently in this sorted map.
  Specified by:
    `firstKey` in interface `SortedMap`
  Returns:
    the first (lowest) key currently in this sorted map.
  Throws:
    `NoSuchElementException` - Map is empty.

### lastKey

    public Object lastKey()

  Returns the last (highest) key currently in this sorted map.
  Specified by:
    `lastKey` in interface `SortedMap`
  Returns:
    the last (highest) key currently in this sorted map.
  Throws:
    `NoSuchElementException` - Map is empty.

### putAll

    public void putAll(Map map)

  Copies all of the mappings from the specified map to this map. These mappings replace any mappings that this map had for any of the keys currently in the specified map.
  Specified by:
    `putAll` in interface `Map`
  Overrides:
    `putAll` in class `AbstractMap`
  Parameters:
    `map` - mappings to be stored in this map.
  Throws:
    `ClassCastException` - class of a key or value in the specified map prevents it from being stored in this map.
    `NullPointerException` - this map does not permit `null` keys and a specified key is `null`.

### put

    public Object put(Object key,
                      Object value)

  Associates the specified value with the specified key in this map. If the map previously contained a mapping for this key, the old value is replaced.
  Specified by:
    `put` in interface `Map`
  Overrides:
    `put` in class `AbstractMap`
  Parameters:
    `key` - key with which the specified value is to be associated.
    `value` - value to be associated with the specified key.
  Returns:
    previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the map previously associated `null` with the specified key.
  Throws:
    `ClassCastException` - key cannot be compared with the keys currently in the map.
    `NullPointerException` - key is `null` and this map uses natural order, or its comparator does not tolerate `null` keys.

### remove

    public Object remove(Object key)

  Removes the mapping for this key from this TreeMap if present.
  Specified by:
    `remove` in interface `Map`
  Overrides:
    `remove` in class `AbstractMap`
  Returns:
    previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the map previously associated `null` with the specified key.
  Throws:
    `ClassCastException` - key cannot be compared with the keys currently in the map.
    `NullPointerException` - key is `null` and this map uses natural order, or its comparator does not tolerate `null` keys.

### clear

    public void clear()

  Removes all mappings from this TreeMap.
  Specified by:
    `clear` in interface `Map`
  Overrides:
    `clear` in class `AbstractMap`
  Following copied from interface: `java.util.Map`
  Throws:
    `UnsupportedOperationException` - clear is not supported by this map.

### clone

    public Object clone()

  Returns a shallow copy of this `TreeMap` instance. (The keys and values themselves are not cloned.)
  Overrides:
    `clone` in class `Object`
  Returns:
    a shallow copy of this Map.

### keySet

    public Set keySet()

  Returns a Set view of the keys contained in this map. The set's iterator will return the keys in ascending order. The map is backed by this `TreeMap` instance, so changes to this map are reflected in the Set, and vice-versa. The Set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
  Specified by:
    `keySet` in interface `Map`
  Overrides:
    `keySet` in class `AbstractMap`
  Returns:
    a set view of the keys contained in this TreeMap.

### values

    public Collection values()

  Returns a collection view of the values contained in this map. The collection's iterator will return the values in the order that their corresponding keys appear in the tree. The collection is backed by this `TreeMap` instance, so changes to this map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from the map through the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
  Specified by:
    `values` in interface `Map`
  Overrides:
    `values` in class `AbstractMap`
  Returns:
    a collection view of the values contained in this map.

### entrySet

    public Set entrySet()

  Returns a set view of the mappings contained in this map. The set's iterator returns the mappings in ascending key order. Each element in the returned set is a `Map.Entry`. The set is backed by this map, so changes to this map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from the TreeMap, through the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.
  Specified by:
    `entrySet` in interface `Map`
  Overrides:
    `entrySet` in class `AbstractMap`
  Returns:
    a set view of the mappings contained in this map.
  See Also:
    `Map.Entry`

### subMap

    public SortedMap subMap(Object fromKey,
                            Object toKey)

  Returns a view of the portion of this map whose keys range from `fromKey`, inclusive, to `toKey`, exclusive. (If `fromKey` and `toKey` are equal, the returned sorted map is empty.) The returned sorted map is backed by this map, so changes in the returned sorted map are reflected in this map, and vice-versa. The returned sorted map supports all optional map operations.

  The sorted map returned by this method will throw an `IllegalArgumentException` if the user attempts to insert a key less than `fromKey` or greater than or equal to `toKey`.

  Note: this method always returns a half-open range (which includes its low endpoint but not its high endpoint). If you need a closed range (which includes both endpoints), and the key type allows for calculation of the successor a given key, merely request the subrange from `lowEndpoint` to `successor(highEndpoint)`. For example, suppose that `m` is a sorted map whose keys are strings. The following idiom obtains a view containing all of the key-value mappings in `m` whose keys are between `low` and `high`, inclusive:

          SortedMap sub = m.submap(low, high+"\0");

  A similar technique can be used to generate an open range (which contains neither endpoint). The following idiom obtains a view containing all of the key-value mappings in `m` whose keys are between `low` and `high`, exclusive:

          SortedMap sub = m.subMap(low+"\0", high);

  Specified by:
    `subMap` in interface `SortedMap`
  Parameters:
    `fromKey` - low endpoint (inclusive) of the subMap.
    `toKey` - high endpoint (exclusive) of the subMap.
  Returns:
    a view of the portion of this map whose keys range from `fromKey`, inclusive, to `toKey`, exclusive.
  Throws:
    `ClassCastException` - if `fromKey` and `toKey` cannot be compared to one another using this map's comparator (or, if the map has no comparator, using natural ordering).
    `IllegalArgumentException` - if `fromKey` is greater than `toKey`.
    `NullPointerException` - if `fromKey` or `toKey` is `null` and this map uses natural order, or its comparator does not tolerate `null` keys.

### headMap

    public SortedMap headMap(Object toKey)

  Returns a view of the portion of this map whose keys are strictly less than `toKey`. The returned sorted map is backed by this map, so changes in the returned sorted map are reflected in this map, and vice-versa. The returned sorted map supports all optional map operations.

  The sorted map returned by this method will throw an `IllegalArgumentException` if the user attempts to insert a key greater than or equal to `toKey`.

  Note: this method always returns a view that does not contain its (high) endpoint. If you need a view that does contain this endpoint, and the key type allows for calculation of the successor a given key, merely request a headMap bounded by `successor(highEndpoint)`. For example, suppose that suppose that `m` is a sorted map whose keys are strings. The following idiom obtains a view containing all of the key-value mappings in `m` whose keys are less than or equal to `high`:

           SortedMap head = m.headMap(high+"\0");

  Specified by:
    `headMap` in interface `SortedMap`
  Parameters:
    `toKey` - high endpoint (exclusive) of the headMap.
  Returns:
    a view of the portion of this map whose keys are strictly less than `toKey`.
  Throws:
    `ClassCastException` - if `toKey` is not compatible with this map's comparator (or, if the map has no comparator, if `toKey` does not implement `Comparable`).
    `IllegalArgumentException` - if this map is itself a subMap, headMap, or tailMap, and `toKey` is not within the specified range of the subMap, headMap, or tailMap.
    `NullPointerException` - if `toKey` is `null` and this map uses natural order, or its comparator does not tolerate `null` keys.

### tailMap

    public SortedMap tailMap(Object fromKey)

  Returns a view of the portion of this map whose keys are greater than or equal to `fromKey`. The returned sorted map is backed by this map, so changes in the returned sorted map are reflected in this map, and vice-versa. The returned sorted map supports all optional map operations.

  The sorted map returned by this method will throw an `IllegalArgumentException` if the user attempts to insert a key less than `fromKey`.

  Note: this method always returns a view that contains its (low) endpoint. If you need a view that does not contain this endpoint, and the element type allows for calculation of the successor a given value, merely request a tailMap bounded by `successor(lowEndpoint)`. For For example, suppose that suppose that `m` is a sorted map whose keys are strings. The following idiom obtains a view containing all of the key-value mappings in `m` whose keys are strictly greater than `low`:

           SortedMap tail = m.tailMap(low+"\0");

  Specified by:
    `tailMap` in interface `SortedMap`
  Parameters:
    `fromKey` - low endpoint (inclusive) of the tailMap.
  Returns:
    a view of the portion of this map whose keys are greater than or equal to `fromKey`.
  Throws:
    `ClassCastException` - if `fromKey` is not compatible with this map's comparator (or, if the map has no comparator, if `fromKey` does not implement `Comparable`).
    `IllegalArgumentException` - if this map is itself a subMap, headMap, or tailMap, and `fromKey` is not within the specified range of the subMap, headMap, or tailMap.
    `NullPointerException` - if `fromKey` is `null` and this map uses natural order, or its comparator does not tolerate `null` keys.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >